# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section         free

Name:           ops4j-pax-construct
Summary:        Pax bundle scanner
Url:            http://www.ops4j.org/
Version:        1.1
Release:        1%{?dist}
Epoch:          1
License:        Apache 2.0 License
Group:          Development/Libraries
Source0:        ops4j-org.ops4j.pax.construct-9d415aa.tar.gz
# get it from https://github.com/ops4j/org.ops4j.pax.construct/tree/9d415aaaf324379647a5768755460706edb79004

Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml

Patch0:         ops4j-pax-construct-EclipseOSGiMojo.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-eclipse
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven-archetype
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  apache-commons-parent
BuildRequires:  ops4j-pax-master
BuildRequires:  texen

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:  java >= 0:1.6.0
Requires:  ops4j-pax-master

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
Pax Construct provides a Swiss Army® knife for OSGi that 
helps you rapidly create, build, manage and deploy many 
types of OSGi bundles. The core functionality is provided 
by a flexible Maven2 plugin that enhances and streamlines 
the Maven build process for OSGi, along with intelligent 
archetypes that adapt according to your needs.
Unix and Windows scripts are available to further reduce 
the need to remember (and type) long command strings. These 
scripts come with basic help text and can bootstrap 
themselves from an empty system.
You can use Pax Construct to create a simple first bundle 
in less than a minute, all the way up to managing a Spring 
Dynamic Modules for OSGi (TM) system.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -n ops4j-org.ops4j.pax.construct-9d415aa
chmod -R go=u-w *
cp %{SOURCE1} settings.xml
%patch0 -b .sav0

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL/org/ops4j/maven-inherit-plugin/1.1/
ln -sf $MAVEN_REPO_LOCAL/org/ops4j/maven-inherit-plugin/1.2-SNAPSHOT/maven-inherit-plugin-1.2-SNAPSHOT.jar \
       $MAVEN_REPO_LOCAL/org/ops4j/maven-inherit-plugin/1.1/maven-inherit-plugin-1.1.jar
ln -sf $MAVEN_REPO_LOCAL/org/ops4j/maven-inherit-plugin/1.2-SNAPSHOT/maven-inherit-plugin-1.2-SNAPSHOT.pom \
       $MAVEN_REPO_LOCAL/org/ops4j/maven-inherit-plugin/1.1/maven-inherit-plugin-1.1.pom

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export SETTINGS=$(pwd)/settings.xml

mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install 
mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Daggregate=true \
        javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

%add_to_maven_depmap org.ops4j.pax construct %{version} JPP/%{name} construct
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-construct.pom

%add_to_maven_depmap org.ops4j maven-pax-plugin 1.5 JPP/%{name} maven-pax-plugin
install -m 644 maven-pax-plugin/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-maven-pax-plugin.pom
install -m 644 maven-pax-plugin/target/maven-pax-plugin-1.5-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/maven-pax-plugin-1.5.jar
ln -s maven-pax-plugin-1.5.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/maven-pax-plugin.jar

%add_to_maven_depmap org.ops4j maven-inherit-plugin 1.2 JPP/%{name} maven-inherit-plugin
install -m 644 maven-inherit-plugin/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-maven-inherit-plugin.pom
install -m 644 maven-inherit-plugin/target/maven-inherit-plugin-1.2-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/maven-inherit-plugin-1.2.jar
ln -s maven-inherit-plugin-1.2.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/maven-inherit-plugin.jar

%add_to_maven_depmap org.ops4j.pax.construct archetypes %{version} JPP/%{name} archetypes
install -m 644 archetypes/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-archetypes.pom

%add_to_maven_depmap org.ops4j.pax.construct maven-archetype-osgi-bundle %{version} JPP/%{name} maven-archetype-osgi-bundle
install -m 644 archetypes/maven-archetype-osgi-bundle/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-maven-archetype-osgi-bundle.pom
install -m 644 archetypes/maven-archetype-osgi-bundle/target/maven-archetype-osgi-bundle-%{version}-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/maven-archetype-osgi-bundle-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.construct maven-archetype-osgi-project %{version} JPP/%{name} maven-archetype-osgi-project
install -m 644 archetypes/maven-archetype-osgi-project/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-maven-archetype-osgi-project.pom
install -m 644 archetypes/maven-archetype-osgi-project/target/maven-archetype-osgi-project-%{version}-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/maven-archetype-osgi-project-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.construct maven-archetype-osgi-service %{version} JPP/%{name} maven-archetype-osgi-service
install -m 644 archetypes/maven-archetype-osgi-service/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-maven-archetype-osgi-service.pom
install -m 644 archetypes/maven-archetype-osgi-service/target/maven-archetype-osgi-service-%{version}-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/maven-archetype-osgi-service-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.construct maven-archetype-osgi-wrapper %{version} JPP/%{name} maven-archetype-osgi-wrapper
install -m 644 archetypes/maven-archetype-osgi-wrapper/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-maven-archetype-osgi-wrapper.pom
install -m 644 archetypes/maven-archetype-osgi-wrapper/target/maven-archetype-osgi-wrapper-%{version}-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/maven-archetype-osgi-wrapper-%{version}.jar

%add_to_maven_depmap org.ops4j.pax.construct maven-archetype-spring-bean %{version} JPP/%{name} maven-archetype-spring-bean
install -m 644 archetypes/maven-archetype-spring-bean/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-maven-archetype-spring-bean.pom
install -m 644 archetypes/maven-archetype-spring-bean/target/maven-archetype-spring-bean-%{version}-SNAPSHOT.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/maven-archetype-spring-bean-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/*

%changelog
* Sun Jun 19 2011 Ralph Apel <r.apel at r-apel.de> 0:1.1-1
- First standalone release
